unit wpDefActions7;
{ -----------------------------------------------------------------------------
  Copyright (C) 2002-2013 by wpcubed GmbH - Author: Julian Ziersch
  info: http://www.wptools.de                         mailto:support@wptools.de
         __    __  ___  _____            _       _____
        / / /\ \ \/ _ \/__   \___   ___ | |___  |___  |
        \ \/  \/ / /_)/  / /\/ _ \ / _ \| / __|    / /
         \  /\  / ___/  / / | (_) | (_) | \__ \   / /
          \/  \/\/      \/   \___/ \___/|_|___/  /_/
  *****************************************************************************
   PREDEFINED ACTIONLIST AND TOOLS
  -----------------------------------------------------------------------------
  THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY
  KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
  ----------------------------------------------------------------------------- }

interface

{$I WPINC.INC}

{$IFDEF DELPHI5}
This unit is not supported in Delphi 5 because it uses some, WPSymDlgEx,
  wpManHeadFoot, WPSearchDlg, WPUtil, WpParBrd2, Menus, WPPrvFrm, WpPagPrp,
  WPCTRStyleCol, WP1Style, WPStyles, WPTabdlg, WPBltDlg, WpParBrd,
  WpParPrp, WPRTEDefsConsts, WPTblDlg, WPAction, ActnList, Classes,
  WPCTRRich, ImgList, Controls new image lists
{$ENDIF}

{$IFDEF VER240}
{$DEFINE DELPHIXE3}
{$ENDIF}

{$IFDEF VER250}
{$DEFINE DELPHIXE3}
{$ENDIF}

uses
  {$IFDEF DELPHIXE}WinAPI.Windows, WinAPI.Messages,  {$ELSE} Windows, Messages, {$ENDIF}
  ActnList, SysUtils, Classes, Menus, Forms, WPCtrRich,
  {$IFDEF WPXPRN} WPX_Dialogs, {$ELSE} Dialogs, {$ENDIF}
  WPCtrMemo, WPRTEDefs, WPObj_Image, WPPrvFrm, WpPagPrp, WPCTRStyleCol,
  WP1Style, WPStyles, WPTabdlg, WPBltDlg, WpParBrd, WpParPrp, WPTblDlg,
  WPUtil, WpParBrd2,
 WPSymDlgEx,
  WPAction, ImgList, Controls, wpManHeadFoot
{$IFDEF WPREPORTER}
  , WPRTEReport, WPRepED
{$ENDIF}
{$IFDEF WPPREMIUM}
  , WPOBJ_TextBox
{$ENDIF}
  , WPRTEDefsConsts, WPRTEPlatform, WPSearchDlg
  {$IFDEF DELPHIXE3}
  , System.Actions
  {$ELSE}
  // , Actions
  {$ENDIF}
  ;

  // there is aditional "System.Actions" it was added by Delphi XE.
  // Please simply delete it

type
  TWPDefaultActions = class;
  TWPGetCurrentEditor =
    procedure(Sender: TObject; var wp: TWPCustomRichText) of object;

  TWPGlobalProcedure = procedure; // GLOBAL! not 'of object' !

  TWPDefAct = class(TDataModule)
  {$IFNDEF T2H}
    MainMenu: TMainMenu;
    File1: TMenuItem;
    New1: TMenuItem;
    Open1: TMenuItem;
    CloseFile1: TMenuItem;
    N1: TMenuItem;
    Save1: TMenuItem;
    SaveAs1: TMenuItem;
    Export1: TMenuItem;
    N2: TMenuItem;
    PageLayout1: TMenuItem;
    PrintPreview1: TMenuItem;
    Print1: TMenuItem;
    N3: TMenuItem;
    MailTo1: TMenuItem;
    Properties1: TMenuItem;
    N4: TMenuItem;
    CloseApp1: TMenuItem;
    Edit1: TMenuItem;
    Redo1: TMenuItem;
    Undo1: TMenuItem;
    N5: TMenuItem;
    Cut1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    N6: TMenuItem;
    Delete1: TMenuItem;
    ParagraphFormat1: TMenuItem;
    CharacterFormat1: TMenuItem;
    ext1: TMenuItem;
    SelectAll1: TMenuItem;
    All1: TMenuItem;
    able1: TMenuItem;
    N7: TMenuItem;
    Search1: TMenuItem;
    Replace1: TMenuItem;
    View1: TMenuItem;
    Normal1: TMenuItem;
    PageLayout2: TMenuItem;
    Zoom1: TMenuItem;
    PageWidth1: TMenuItem;
    FullPage1: TMenuItem;
    DoublePage1: TMenuItem;
    N10: TMenuItem;
    N4001: TMenuItem;
    N2001: TMenuItem;
    N1001: TMenuItem;
    N751: TMenuItem;
    N501: TMenuItem;
    N251: TMenuItem;
    N11: TMenuItem;
    humbNails1: TMenuItem;
    N9: TMenuItem;
    ManageHeaderFooter1: TMenuItem;
    N8: TMenuItem;
    ShowVertRuler1: TMenuItem;
    ShowThumbNails1: TMenuItem;
    Insert1: TMenuItem;
    PageBreak1: TMenuItem;
    SectionBreak1: TMenuItem;
    N12: TMenuItem;
    Graphic1: TMenuItem;
    PageNumbers1: TMenuItem;
    Format1: TMenuItem;
    Font1: TMenuItem;
    Paragraph1: TMenuItem;
    Numbers1: TMenuItem;
    Border1: TMenuItem;
    ColumnsMenu1: TMenuItem;
    abstops1: TMenuItem;
    N14: TMenuItem;
    Capitalisation1: TMenuItem;
    ExtrasMenu: TMenuItem;
    Spellcheck1: TMenuItem;
    SpellAsYouGo1: TMenuItem;
    hesaurus1: TMenuItem;
    able2: TMenuItem;
    NewTable1: TMenuItem;
    Insert2: TMenuItem;
    Rows1: TMenuItem;
    Columns2: TMenuItem;
    Delete2: TMenuItem;
    Row1: TMenuItem;
    Column1: TMenuItem;
    Select1: TMenuItem;
    able4: TMenuItem;
    Row2: TMenuItem;
    Column2: TMenuItem;
    N15: TMenuItem;
    SplitCell1: TMenuItem;
    SplitTable1: TMenuItem;
    N17: TMenuItem;
    Info1: TMenuItem;
    Info2: TMenuItem;
    StdIcons: TImageList;
    StdActions: TActionList;
    aBrd_BBottom: TWPABBottom;
    aInsert_Field: TWPAInsertField;
    aInsert_Hyperlink: TWPAEditHyperlink;
    aBrd_Left: TWPABLeft;
    aBrd_Top: TWPABTop;
    aBrd_AllOff: TWPABAllOff;
    aTbl_DelRow: TWPADelRow;
    aBrd_Inner: TWPABInner;
    aBrd_Outer: TWPABOuter;
    aTbl_CreateTable: TWPACreateTable;
    aTbl_CombineCell: TWPACombineCell;
    aTbl_SplitCells: TWPASplitCells;
    aTbl_InsRow: TWPAInsRow;
    aTbl_SelectColumn: TWPASelectColumn;
    aTbl_SelectRow: TWPASelectRow;
    aZoom_Out: TWPAZoomOut;
    aZoom_ZoomIn: TWPAZoomIn;
    aView_FitHeight: TWPAFitHeight;
    aView_FitWidth: TWPAFitWidth;
    aView_Print: TWPAPrint;
    aView_PrinterSetup: TWPAPrinterSetup;
    aView_PriorPage: TWPAPriorPage;
    aView_NextPage: TWPANextPage;
    aAlign_Left: TWPALeft;
    aAlign_Center: TWPACenter;
    aAlign_Right: TWPARight;
    aAlign_Justified: TWPAJustified;
    aNum_Bullets: TWPABullets;
    aNum_Numbers: TWPANumbers;
    aPar_DecIndent: TWPADecIndent;
    aPar_IncIndent: TWPAIncIndent;
    aFile_Open1: TWPAOpen;
    aFile_Save: TWPASave;
    aFile_Exit: TWPAExit;
    aFile_Close: TWPAClose;
    aFile_New: TWPANew;
    aEdit_Undo: TWPAUndo;
    aEdit_Copy: TWPACopy;
    aEdit_Cut: TWPACut;
    aEdit_Paste: TWPAPaste;
    aEdit_Search: TWPASearch;
    aEdit_Replace: TWPAReplace;
    aEdit_SellectAll: TWPASellAll;
    aEdit_HideSelection: TWPAHideSelection;
    aEdit_Spellcheck: TWPASpellcheck;
    aDB_Cancel: TWPACancel;
    aDB_Delete: TWPADelete;
    aDB_Add: TWPAAdd;
    aDB_Edit: TWPAEdit;
    aDB_Next: TWPANext;
    aDB_Back: TWPABack;
    aDB_OK: TWPAOK;
    aDB_ToEnd: TWPAToEnd;
    aDB_ToStart: TWPAToStart;
    aSTY_Normal: TWPANorm;
    aSTY_Bold: TWPABold;
    aSTY_Italic: TWPAItalic;
    aSTY_Protected: TWPAProtected;
    aSTY_Hidden: TWPAHidden;
    aSTY_CODE: TWPARTFCode;
    aSTY_Underline: TWPAUnderline;
    aSTY_Strikeout: TWPAStrikeout;
    aSTY_Subscript: TWPASubscript;
    aSTY_Superscript: TWPASuperscript;
    aTbl_InsCol: TWPAInsCol;
    aTbl_DelCol: TWPADelCol;
    aEdit_Redo: TWPARedo;
    aEdit_DeleteText: TWPADeleteText;
    aNum_OutlineMode: TWPAIsOutlineMode;
    aNum_OutlineUp: TWPAInOutlineUp;
    aNum_OutlineDown: TWPAInOutlineDown;
    aEdit_SpellAsYouGo: TWPASpellAsYouGo;
    aEdit_StartThesaurus: TWPAStartThesaurus;
    WPTableDlg1: TWPTableDlg;
    WPParagraphPropDlg1: TWPParagraphPropDlg;
    WPParagraphBorderDlg1: TWPParagraphBorderDlg;
    WPBulletDlg1: TWPBulletDlg;
    WPTabDlg1: TWPTabDlg;
    WPStyleDlg1: TWPStyleDlg;
    WPOneStyleDlg1: TWPOneStyleDlg;
    WPStyleCollection1: TWPStyleCollection;
    WPPagePropDlg1: TWPPagePropDlg;
    WPPreviewDlg1: TWPPreviewDlg;
    DemoIcons: TImageList;
    Print2: TMenuItem;
    XA_ShowVertRuler: TAction;
    XA_ShowThumbnails: TAction;
    ShowHorzRuler1: TMenuItem;
    Symbol1: TMenuItem;
    Page: TMenuItem;
    NextPage1: TMenuItem;
    PriorPage1: TMenuItem;
    NumPages1: TMenuItem;
    Fields1: TMenuItem;
    Date1: TMenuItem;
    ime1: TMenuItem;
    Named1: TMenuItem;
    N19: TMenuItem;
    MailmergeField1: TMenuItem;
    N21: TMenuItem;
    ColumnsOff: TMenuItem;
    Col21: TMenuItem;
    Col31: TMenuItem;
    Col41: TMenuItem;
    ColumnBreak1: TMenuItem;
    Lowercase: TMenuItem;
    Uppercase: TMenuItem;
    Hyperlink1: TMenuItem;
    N22: TMenuItem;
    Bookmark1: TMenuItem;
    XA_Info: TAction;
    ReportingMenu: TMenuItem;
    InsertField1: TMenuItem;
    PropertyDialog1: TMenuItem;
    CreateReport1: TMenuItem;
    XA_ShowRepBand: TAction;
    XA_CreateReport: TAction;
    GraphicPopupMenu: TPopupMenu;
    ascharacter1: TMenuItem;
    reltoparautowrap1: TMenuItem;
    reltoparwrapleftandright1: TMenuItem;
    reltopagenowrappng1: TMenuItem;
    reltopagewrapleftandright1: TMenuItem;
    GraphicOptions1: TMenuItem;
    ascharacter2: TMenuItem;
    reltoparautowrapleftorright1: TMenuItem;
    reltoparwrapleftandright2: TMenuItem;
    reltopagenowrappng2: TMenuItem;
    reltopagewrapleftandright2: TMenuItem;
    ShowGutter1: TMenuItem;
    InsTextBox: TMenuItem;
    ShowMailMergeFields: TMenuItem;
    ShowSpecialChars: TMenuItem;
    SelectLanguage1: TMenuItem;
    SpellCheckOptions1: TMenuItem;
    underovertext1: TMenuItem;
    InsertFormField1: TMenuItem;
    WPParagraphBorderDlgEx1: TWPParagraphBorderDlgEx;
    WPDialogCollection1: TWPDialogCollection;
    WPSearchReplaceDlg1: TWPSearchReplaceDlg;
    WPManageHeaderFooterDlg1: TWPManageHeaderFooterDlg;
    WPSymbolDlgEx1: TWPSymbolDlgEx;
    aBrd_Right: TWPABRight;
    aBrd_AllOn: TWPABAllOn;
    aTbl_CombineColumns: TWPACombineColumns;
    aTbl_SplitColumns: TWPASplitColumns;
    aTbl_SplitRows: TWPASplitRows;
    aTbl_MergeRows: TWPAMergeRows;
    aTbl_CombineTables: TWPACombineTables;
    aTbl_SplitTable: TWPASplitTable;
    aCOL_ColOFF: TWPAColumnsOFF;
    aCOL_Col2: TWPAColumnsSet2;
    aCOL_Col3: TWPAColumnsSet3;
    aCOL_Col4: TWPAColumnsSet4;
    aView_ShowMargins: TWPAShowMargins;
    aImage_Insert: TWPAInsertImage;
    aImage_WrapRight: TWPAImageWrapRight;
    aImage_WrapLeft: TWPAImageWrapLeft;
    aImage_WrapBoth: TWPAImageWrapBoth;
    aImage_NoWrap: TWPAImageNoWrap;
    aImage_Properties1: TWPAImageProperties;
    aInsert_Symbol1: TWPAInsertSymbol;
    aInsert_Pagenumber: TWPAInsertPagenumber;
    aInsert_Pagecount: TWPAInsertPagecount;
    aInsert_Footnote: TWPAInsertFootnote;
    aMove_Next: TWPAMoveNextItem;
    aMove_Highlight: TWPAMoveHighlight;
    aMove_Table: TWPAMoveTable;
    aMove_Bookmark: TWPAMoveBookmark;
    aMove_Image: TWPAMoveImage;
    aMove_Header: TWPAMoveHeader;
    aMove_Footer: TWPAMoveFooter;
    aMove_Hyperlink: TWPAMoveHyperlink;
    aMove_Annotation: TWPAMoveAnnotation;
    aMove_Pagebreak: TWPAMovePagebreak;
    aMove_Field: TWPAMoveField;
    aMove_Footnote: TWPAMoveFootnote;
    aCLIP_CopyAttributes: TWPACopyAttributes;

    aSTY_GrowFont: TWPAIncreaseFontsize;
    aSTY_ShrinkFont: TWPADecreaseFontsize;
    aPar_Protect: TWPAParagraphProtect;
    aPar_KeepTogether1: TWPAParagraphKeepTogether;
    aPar_Normalize: TWPANormalizeParagraph;
    aDIA_ManageHeaderFooter: TWPAManageHeaderFooter;
    aDIA_SetupPage: TWPASetupPage;
    aDIA_PreviewDialog: TWPAPreviewDialog;
    aZoom_Zoom100: TWPAZoom100;
    aZoom_Width: TWPAZoomWidth;
    aZoom_Fullpage: TWPAZoomFull;
    aZoom_LayoutNormal: TWPALayoutNormal;
    aZoom_LayoutFull: TWPALayoutFull;
    aZoom_LayoutDouble: TWPALayoutDouble;
    aZoom_LayoutColumns: TWPALayoutColumns;
    aView_ShowGridlines: TWPAShowGridlines;
    aView_ShowSpecialchar: TWPAShowSpecialchar;
    aDIA_Borders: TWPADiaBorders;
    aDIA_BulletOutline: TWPADiaBulletOutline;
    aDIA_Formulas: TWPADiaFormulas;
    aDIA_ParagraphProperties: TWPADiaParagraphProperties;
    aDIA_Tabstops: TWPADiaTabstops;
    aDIA_EditCurrentStyle: TWPADiaEditCurrentStyle;
    aDIA_DiaStyleSheet: TWPADiaStyleSheet;
    aDIA_SectionProps: TWPADiaSectionProps;
    aDIA_CreateTable: TWPADiaCreateTable;
    aDIA_ReportBand: TWPADiaReportBand;
    aDIA_PDFExport: TWPADiaPDFExport;
    aSTY_Uppercase: TWPAToUppercase;
    aSTY_Lowercase: TWPAToLowercase;
    aInsert_PagenrNext: TWPAInsPagenrNext;
    aInsert_PagenrPrev: TWPAInsPagenrPrev;
    aInsert_Date: TWPAInsDate;
    XA_ShowHorzRuler: TAction;
    aSTY_AttributeBrush: TWPAAttributesBrush;
    aEdit_CopyAttributes: TWPACopyAttributes;
    aFile_SaveAs: TWPASave;
    procedure XA_CloseExecute(Sender: TObject);
    procedure XA_DocPropExecute(Sender: TObject);
    procedure XA_MailToExecute(Sender: TObject);
    procedure XA_PrintExecute(Sender: TObject);
    procedure XA_PrintDialogExecute(Sender: TObject);
    procedure XA_DiaPreviewExecute(Sender: TObject);
    procedure XA_DiaPageSetupExecute(Sender: TObject);
    procedure XA_ExportFileExecute(Sender: TObject);
    procedure XA_NewExecute(Sender: TObject);
    procedure XA_ShowHorzRulerExecute(Sender: TObject);
    procedure XA_ShowVertRulerExecute(Sender: TObject);
    procedure XA_ShowThumbnailsExecute(Sender: TObject);
    procedure XA_InsPageBreakExecute(Sender: TObject);
    procedure XA_InsColumnBreakExecute(Sender: TObject);
    procedure XA_InsSectionBreakExecute(Sender: TObject);
    procedure DataModuleCreate(Sender: TObject);
    procedure DataModuleDestroy(Sender: TObject);
    procedure XA_InsSymbolExecute(Sender: TObject);
    procedure XA_FInsPageExecute(Sender: TObject);
    procedure XA_InsNamedFieldExecute(Sender: TObject);
    procedure XA_InsMailmergeFieldExecute(Sender: TObject);
    procedure XA_FrmFontDialogExecute(Sender: TObject);
    procedure XA_FrmBorderExecute(Sender: TObject);
    procedure XA_FrmIndentSpacingExecute(Sender: TObject);
    procedure XA_FrmNumbersExecute(Sender: TObject);
    procedure XA_FrmCap_LowercaseExecute(Sender: TObject);
    procedure XA_FrmCap_UppercaseExecute(Sender: TObject);
    procedure XA_FrmCap_OffExecute(Sender: TObject);
    procedure XA_FrmTabStopsExecute(Sender: TObject);
    procedure XA_CreateTableExecute(Sender: TObject);
    procedure XA_InsHyperlinkExecute(Sender: TObject);
    procedure XA_InsBookmarkExecute(Sender: TObject);
    procedure Info1Click(Sender: TObject);
    procedure XA_InfoExecute(Sender: TObject);
    procedure XA_ShowRepBandExecute(Sender: TObject);
    procedure XA_CreateReportExecute(Sender: TObject);
    procedure XA_InsGraphicExecute(Sender: TObject);
    procedure GraphicOptionsClick(Sender: TObject);
    procedure InsTextBoxClick(Sender: TObject);
    procedure ShowGutter1Click(Sender: TObject);
    procedure ShowMailMergeFieldsClick(Sender: TObject);
    procedure ShowSpecialCharsClick(Sender: TObject);
    procedure XA_LoadExecute(Sender: TObject);
    procedure XA_SaveExecute(Sender: TObject);
    procedure XA_SaveAsExecute(Sender: TObject);
    procedure XA_CloseFileExecute(Sender: TObject);
    procedure MDIActionsUpdate(Action: TBasicAction; var Handled: Boolean);
    procedure GraphicPopupMenuPopup(Sender: TObject);
    procedure InsertFormField1Click(Sender: TObject);
    procedure SetFGetWPRichText(x : TWPGetCurrentEditor);
    procedure aFile_SaveBeforeExecute(Action: TObject; var Ignore: Boolean);
    procedure aFile_SaveAsBeforeExecute(Action: TObject; var Ignore: Boolean);
  private
    FOwnerComp: TWPDefaultActions;
    FGetWPRichText: TWPGetCurrentEditor;
    FBookCount, FFieldCount: Integer;
    FOnInfo, FOnInfo2: TWPGlobalProcedure;
    function GetTheWPRichText: TWPCustomRichText;
  {$ENDIF}
  public
{$IFDEF WPREPORTER}
    SuperMerge: TWPSuperMerge;
    BandDialog: TWPReportBandsDialog;
    ReportDest: TWPRichText;
{$ENDIF}


    //:: Loads the strings from the localisation interface
    procedure LoadStrings;
    //:: Saves the strings to the localisation interface
    procedure SaveStrings;
    property OnInfo: TWPGlobalProcedure read FOnInfo write FOnInfo;
    property OnGetWPRichText: TWPGetCurrentEditor read FGetWPRichText write SetFGetWPRichText;
    property WPRichText1: TWPCustomRichText read GetTheWPRichText;
  end;

  TWPInitializeActions = procedure(
    ActionModule: TWPDefAct) of object;

  TWPRichTextAction = procedure(
    Sender: TObject;
    ActionModule: TWPDefAct;
    WPRichText: TWPCustomRichText) of object;

  { The component TWPDefaultActions make it easy to use the default actions.
      You can place it on your form, add an item for the controlled TWPRichText object
      and start the application. }
  TWPDefaultActions = class(TComponent)
  private
{$IFNDEF T2H}
    FWPDefAct: TWPDefAct;
    FLastEditor: TWPCustomRichText;
    FAssignMenu: Boolean;
    FOwnerForm: TForm;
    FControlledMemos: TWPEditBoxLinkCollection;
    FOnInfo2: TNotifyEvent;
    FOnInfo1: TNotifyEvent;
    FOnInit: TWPInitializeActions;
    FOnExport: TWPRichTextAction;
    FOnMailTo: TWPRichTextAction;
    FOnClose: TWPRichTextAction;
    FOnCloseFile: TWPRichTextAction;
    FOnNew: TWPRichTextAction;
    FOnLoad: TWPRichTextAction;
    FOnSave: TWPRichTextAction;
    FOnSaveAs: TWPRichTextAction;
    FOnShowHorzRuler: TWPRichTextAction;
    FOnShowVertRuler: TWPRichTextAction;
    FOnShowGutter: TWPRichTextAction;
    FOnShowThumbnails: TWPRichTextAction;
    procedure SetLinks(x: TWPEditBoxLinkCollection);
  protected
    procedure EditBoxStateMsg(Sender: TPersistent; EditBox: TWPCustomRtfEdit; State: TWPEditBoxLinkMsg); virtual;
    procedure GetToolsEditor(Sender: TObject; var wp: TWPCustomRichText); virtual;
    procedure Loaded; override;
{$ENDIF}
  public
    constructor Create(aOwner: TComponent); override;
    destructor Destroy; override;

    property WPDefAct: TWPDefAct read FWPDefAct;
  published
    property ControlledMemos: TWPEditBoxLinkCollection read
      FControlledMemos write SetLinks;
    property AssignMenu: Boolean read FAssignMenu write FAssignMenu;
    property OnInfo2: TNotifyEvent read FOnInfo2 write FOnInfo2;
    property OnInfo1: TNotifyEvent read FOnInfo1 write FOnInfo1;
    property OnInit: TWPInitializeActions read FOnInit write FOnInit;
    property OnExport: TWPRichTextAction read FOnExport write FOnExport;
    property OnMailTo: TWPRichTextAction read FOnMailTo write FOnMailTo;
    {:: This event is triggered when the user selectes the 'Close Application' menu item. }
    property OnClose: TWPRichTextAction read FOnClose write FOnClose;
    property OnCloseFile: TWPRichTextAction read FOnCloseFile write FOnCloseFile;
    property OnNew: TWPRichTextAction read FOnNew write FOnNew;
    property OnLoad: TWPRichTextAction read FOnLoad write FOnLoad;
    property OnSave: TWPRichTextAction read FOnSave write FOnSave;
    property OnSaveAs: TWPRichTextAction read FOnSaveAs write FOnSaveAs;
    property OnShowHorzRuler: TWPRichTextAction read FOnShowHorzRuler write FOnShowHorzRuler;
    property OnShowVertRuler: TWPRichTextAction read FOnShowVertRuler write FOnShowVertRuler;
    property OnShowGutter: TWPRichTextAction read FOnShowGutter write FOnShowGutter;
    property OnShowThumbnails: TWPRichTextAction read FOnShowThumbnails write FOnShowThumbnails;


  end;


{ This must be created by main form }

  var // WPDefAct : TWPDefaultActions ;
      WPDefaultActions : TWPDefaultActions;

implementation

uses WPDocPropDlg;

{$R *.dfm}

procedure TWPDefAct.aFile_SaveBeforeExecute(Action: TObject;
  var Ignore: Boolean);
begin
  Ignore := true;
  if assigned(FOwnerComp) and assigned(FOwnerComp.FOnSave) then
     FOwnerComp.FOnSave(Action, Self, WPRichText1)
  else if WPRichText1<>nil then
       WPRichText1.Save
  else Ignore := false;
end;

procedure TWPDefAct.aFile_SaveAsBeforeExecute(Action: TObject;
  var Ignore: Boolean);
begin
  Ignore := true;
  if assigned(FOwnerComp) and assigned(FOwnerComp.FOnSaveAs) then
     FOwnerComp.FOnSaveAs(Action, Self, WPRichText1)
  else if WPRichText1<>nil then
       WPRichText1.SaveAs
  else Ignore := false;
end;

procedure TWPDefAct.DataModuleCreate(Sender: TObject);
begin
{$IFNDEF WPPREMIUM}
{$IFNDEF SHOW_WPPREMIUM}
  ColumnBreak1.Visible := FALSE;
  ColumnsMenu1.Visible := FALSE;
  InsTextBox.Visible := FALSE;
{$ENDIF}
  InsTextBox.Enabled := FALSE;
{$ELSE} // for WPTools Premium
  InsTextBox.Visible := TRUE;
  ColumnBreak1.Visible := TRUE;
  ColumnsMenu1.Visible := TRUE;
{$ENDIF}
  ExtrasMenu.Visible := FALSE;
{$IFDEF WPREPORTER}
  BandDialog := TWPReportBandsDialog.Create(Self);
{$ELSE}
  ReportingMenu.Visible := FALSE;
{$ENDIF}
end;

procedure TWPDefAct.DataModuleDestroy(Sender: TObject);
var i : Integer;
begin
  for i:=StdActions.ActionCount - 1 downto 0 do
      StdActions.Actions[i].Free;
end;

function TWPDefAct.GetTheWPRichText: TWPCustomRichText;
begin
  if Assigned(FGetWPRichText) then
  begin
    Result := nil;
    FGetWPRichText(Self, Result);
{$IFDEF WPREPORTER}
    if ReportingMenu.Visible <> (SuperMerge <> nil) then
      ReportingMenu.Visible := SuperMerge <> nil;
{$ENDIF}
  end
  else raise Exception.Create('Please assign event TWPDefAct.OnGetWPRichText');
end;

procedure TWPDefAct.MDIActionsUpdate(Action: TBasicAction;
  var Handled: Boolean);
begin
 { if (Action <> XA_Load) and (Action <> XA_New) and (Action <> XA_Info) and (Action <> XA_Close) then
  begin
    if GetTheWPRichText = nil then
    begin
      Handled := TRUE;
      (Action as TAction).Enabled := FALSE;
    end else (Action as TAction).Enabled := TRUE;
  end; }
end;

// -------------------------
// -------- File Menu
// -------------------------


procedure TWPDefAct.XA_CloseExecute(Sender: TObject);
begin
     // TODO
  if (FOwnerComp <> nil) and
    assigned(FOwnerComp.FOnClose) then
    FOwnerComp.FOnClose(Sender, Self, WPRichText1);
end;

procedure TWPDefAct.XA_DocPropExecute(Sender: TObject);
begin
  if WPRichText1 <> nil then
    with TWPDocProperties.Create(WPRichText1) do
    try
      Source := Self.WPRichText1;
      ShowModal;
    finally
      Free;
    end;
end;

procedure TWPDefAct.XA_MailToExecute(Sender: TObject);
begin
   // TODO
  if (FOwnerComp <> nil) and
    assigned(FOwnerComp.FOnMailTo) then
    FOwnerComp.FOnMailTo(Sender, Self, WPRichText1);
end;

procedure TWPDefAct.XA_PrintExecute(Sender: TObject);
var b: Boolean;
begin
  if WPRichText1 <> nil then
  begin
    b := WPRichText1.InsertPointAttr.Hidden;
    try
      WPRichText1.InsertPointAttr.Hidden := TRUE;
      WPRichText1.Print;
    finally
      WPRichText1.InsertPointAttr.Hidden := b;
    end;
  end;
end;

procedure TWPDefAct.XA_PrintDialogExecute(Sender: TObject);
var b: Boolean;
begin
  if WPRichText1 <> nil then
  begin
    b := WPRichText1.InsertPointAttr.Hidden;
    try
      WPRichText1.InsertPointAttr.Hidden := TRUE;
      WPRichText1.PrintDialog;
    finally
      WPRichText1.InsertPointAttr.Hidden := b;
    end;
  end;
end;

procedure TWPDefAct.XA_DiaPreviewExecute(Sender: TObject);
begin
  WPPreviewDlg1.EditBox := WPRichText1;
  {$IFDEF PREVIEW_FULL50}
  WPPreviewDlg1.WindowState := wsMaximized;
  WPPreviewDlg1.ZoomMode := wpPvFullPage; // wp50Percent;
  {$ENDIF}
  WPPreviewDlg1.Execute;
end;

procedure TWPDefAct.XA_DiaPageSetupExecute(Sender: TObject);
begin
  WPPagePropDlg1.EditBox := WPRichText1;
  WPPagePropDlg1.Execute;
end;

procedure TWPDefAct.XA_ExportFileExecute(Sender: TObject);
begin
  if (WPRichText1 <> nil) and (FOwnerComp <> nil) and
    assigned(FOwnerComp.FOnExport) then
    FOwnerComp.FOnExport(Sender, Self, WPRichText1);
end;

procedure TWPDefAct.XA_NewExecute(Sender: TObject);
begin
  //TODO: Load Template ?
  if (FOwnerComp <> nil) and
    assigned(FOwnerComp.FOnNew) then
    FOwnerComp.FOnNew(Sender, Self, WPRichText1)
  else if WPRichText1 <> nil then
  begin
    if WPRichText1.CanClose then
      WPRichText1.Clear;
    WPRichText1.CheckHasBody;
  end;
end;

procedure TWPDefAct.XA_LoadExecute(Sender: TObject);
begin
  if (FOwnerComp <> nil) and
    assigned(FOwnerComp.FOnLoad) then
    FOwnerComp.FOnLoad(Sender, Self, WPRichText1)
  else if WPRichText1 <> nil then WPRichText1.Load;
end;

procedure TWPDefAct.XA_CloseFileExecute(Sender: TObject);
begin
  if (FOwnerComp <> nil) and
    assigned(FOwnerComp.FOnCloseFile) then
    FOwnerComp.FOnCloseFile(Sender, Self, WPRichText1);
end;

procedure TWPDefAct.XA_SaveExecute(Sender: TObject);
begin
  if (FOwnerComp <> nil) and
    assigned(FOwnerComp.FOnSave) then
    FOwnerComp.FOnSave(Sender, Self, WPRichText1)
  else if WPRichText1 <> nil then WPRichText1.Save;
end;

procedure TWPDefAct.XA_SaveAsExecute(Sender: TObject);
begin
  if (FOwnerComp <> nil) and
    assigned(FOwnerComp.FOnSaveAs) then
    FOwnerComp.FOnSaveAs(Sender, Self, WPRichText1)
  else if WPRichText1 <> nil then WPRichText1.SaveAs;
end;

// -------------------------
// -------- EDIT Menu
// -------------------------

procedure TWPDefAct.ShowMailMergeFieldsClick(Sender: TObject);
begin
  WPRichText1.InsertPointAttr.Hidden :=
    not WPRichText1.InsertPointAttr.Hidden;
end;

procedure TWPDefAct.ShowSpecialCharsClick(Sender: TObject);
begin
  if wpShowCR in WPRichText1.ViewOptions then
    WPRichText1.ViewOptions := WPRichText1.ViewOptions -
      [wpShowCR, wpShowFF, wpShowNL, wpShowSPC,
      wpShowHardSPC, wpShowTAB] else
    WPRichText1.ViewOptions := WPRichText1.ViewOptions +
      [wpShowCR, wpShowFF, wpShowNL, wpShowSPC, wpShowHardSPC, wpShowTAB];
end;



procedure TWPDefAct.XA_ShowHorzRulerExecute(Sender: TObject);
begin
  //TODO
  if (FOwnerComp <> nil) and
    assigned(FOwnerComp.FOnShowHorzRuler) then
    FOwnerComp.FOnShowHorzRuler(Sender, Self, WPRichText1);
end;

procedure TWPDefAct.XA_ShowVertRulerExecute(Sender: TObject);
begin
  //TODO
  if (FOwnerComp <> nil) and
    assigned(FOwnerComp.FOnShowVertRuler) then
    FOwnerComp.FOnShowVertRuler(Sender, Self, WPRichText1);
end;

procedure TWPDefAct.XA_ShowThumbnailsExecute(Sender: TObject);
begin
   // TODO
  if (FOwnerComp <> nil) and
    assigned(FOwnerComp.FOnShowThumbnails) then
    FOwnerComp.FOnShowThumbnails(Sender, Self, WPRichText1);
end;

procedure TWPDefAct.ShowGutter1Click(Sender: TObject);
begin
   // TODO
  if (FOwnerComp <> nil) and
    assigned(FOwnerComp.FOnShowGutter) then
    FOwnerComp.FOnShowGutter(Sender, Self, WPRichText1);
end;


// -------------------------
// -------- Insert Menu
// -------------------------

procedure TWPDefAct.XA_InsGraphicExecute(Sender: TObject);
begin
  if (WPRichText1 <> nil) then WPRichText1.InsertGraphicDialog;
end;

procedure TWPDefAct.InsTextBoxClick(Sender: TObject);
{$IFDEF WPPREMIUM}
var obj: TWPORTFTextBox;
  txtobj: TWPTextObj;
begin
  if (WPRichText1 <> nil) then
  begin
    if WPRichText1.CursorOnText.Kind <> wpIsBody then
      ShowMessage(WPLoadStr(wpCannotInsObject)) else
    begin
      obj := TWPORTFTextBox.Create(WPRichText1);
      obj.WidthTW := 3000;
      obj.HeightTW := 1000;
      obj.MakeUniqueName;
      obj.AsString := '';
      txtobj := WPRichText1.TextObjects.InsertMovableImage(obj);
      if txtobj <> nil then
      begin
        txtobj.Mode := txtobj.Mode + [wpobjCreateAutoName];
        txtobj.RelX := 1440;
        txtobj.RelY := 0;
        txtobj.Frame := [wpframe1pt, wpframeShadow];
        WPRichText1.ReformatAll;
        obj.Edit;
        WPRichText1.SetFocus;
      end;
    end;
  end;
end;
{$ELSE}
begin end;
{$ENDIF}


procedure TWPDefAct.XA_InsPageBreakExecute(Sender: TObject);
begin
  if (WPRichText1 <> nil) then WPRichText1.InputString(#12);
end;

procedure TWPDefAct.XA_InsColumnBreakExecute(Sender: TObject);
begin
{$IFDEF WPPREMIUM}
  if (WPRichText1 <> nil) then
  begin
    include(WPRichText1.ActiveParagraph.prop, paprNewColumn);
    WPRichText1.ReformatAll(false, true);
  end;
{$ENDIF}
end;

procedure TWPDefAct.XA_InsSectionBreakExecute(Sender: TObject);
var FNewSectionID: Integer;
begin
  if (WPRichText1 <> nil) then
  begin
    WPRichText1.InputString(#12);
    FNewSectionID := WPRichText1.HeaderFooter.LastSectionID + 1;
    WPRichText1.HeaderFooter.LastSectionID := FNewSectionID;
    include(WPRichText1.ActiveParagraph.prop, paprNewSection);
    WPRichText1.ActiveParagraph.SectionID := FNewSectionID;
  end;
end;

procedure TWPDefAct.XA_InsSymbolExecute(Sender: TObject);
begin
  if WPRichText1 <> nil then
  begin
    WPSymbolDlgEx1.EditBox := WPRichText1;
    WPSymbolDlgEx1.Execute;
  end;
end;

procedure TWPDefAct.XA_FInsPageExecute(Sender: TObject);
begin
  if WPRichText1 <> nil then
  begin
    WPRichText1.InputTextField(TWPTextFieldType((Sender as TAction).Tag));
  end;
end;

procedure TWPDefAct.XA_InsNamedFieldExecute(Sender: TObject);
var s: string;
begin
  if WPRichText1 <> nil then
  begin
    s := 'PAGE';
    if InputQuery(WPLoadStr(wpInsertTextField), WPLoadStr(wpInsertTextField_Name), s) then
      WPRichText1.InputTextFieldName(s);
  end;
end;

procedure TWPDefAct.XA_InsMailmergeFieldExecute(Sender: TObject);
var s: string;
begin
  inc(FFieldCount);
  s := 'FIELD' + IntToStr(FFieldCount);
  if (WPRichText1 <> nil) and
    InputQuery(WPLoadStr(wpInsertMailmergeField), WPLoadStr(wpInsertMailmergeField_Name), s) then
    WPRichText1.InputMergeField(s, s);
end;

procedure TWPDefAct.XA_InsHyperlinkExecute(Sender: TObject);
begin
  if (WPRichText1 <> nil) then WPRichText1.EditHyperlink;
end;

procedure TWPDefAct.XA_InsBookmarkExecute(Sender: TObject);
var s: string;
begin
  inc(FBookCount);
  s := 'BOOKM' + IntToStr(FBookCount);
  if (WPRichText1 <> nil) and InputQuery(WPLoadStr(wpInsertBookmark), WPLoadStr(wpInsertBookmark_Name), s) then
    WPRichText1.BookmarkInput(s, false);
end;

procedure TWPDefAct.InsertFormField1Click(Sender: TObject);
var s: string;
begin
  inc(FFieldCount);
  s := 'FIELD' + IntToStr(FFieldCount);
  if (WPRichText1 <> nil) and
    InputQuery(WPLoadStr(wpInsertEditField), WPLoadStr(wpInsertEditField_Name), s) then
    WPRichText1.InputEditField(s, s);
end;

// -------------------------
// -------- Format Menu
// -------------------------

procedure TWPDefAct.XA_FrmFontDialogExecute(Sender: TObject);
begin
  if (WPRichText1 <> nil) then WPRichText1.FontSelect;
end;

procedure TWPDefAct.XA_FrmIndentSpacingExecute(Sender: TObject);
begin
  if WPRichText1 <> nil then
  begin
    WPParagraphPropDlg1.EditBox := WPRichText1;
    WPParagraphPropDlg1.Execute;
  end;
end;

procedure TWPDefAct.XA_FrmBorderExecute(Sender: TObject);
begin
  if WPRichText1 <> nil then
  begin
    //WP7, was: WPParagraphBorderDlg1
    WPParagraphBorderDlgEx1.EditBox := WPRichText1;
    WPParagraphBorderDlgEx1.Execute;
  end;
end;

procedure TWPDefAct.XA_FrmNumbersExecute(Sender: TObject);
begin
  if WPRichText1 <> nil then
  begin
    WPBulletDlg1.EditBox := WPRichText1;
    WPBulletDlg1.Execute;
  end;
end;

procedure TWPDefAct.XA_FrmTabStopsExecute(Sender: TObject);
begin
  if WPRichText1 <> nil then
  begin
    WPTabDlg1.EditBox := WPRichText1;
    WPTabDlg1.Execute;
  end;
end;

procedure TWPDefAct.XA_FrmCap_LowercaseExecute(Sender: TObject);
begin
  if WPRichText1 <> nil then
  begin
    with WPRichText1.TextCursor.CurrAttribute do
    begin
      BeginUpdate;
      ExcludeStyle(afsUppercaseStyle);
      IncludeStyle(afsLowercaseStyle);
      EndUpdate;
    end;
    WPRichText1.Refresh;
  end;
end;

procedure TWPDefAct.XA_FrmCap_UppercaseExecute(Sender: TObject);
begin
  if WPRichText1 <> nil then
  begin
    with WPRichText1.TextCursor.CurrAttribute do
    begin
      BeginUpdate;
      ExcludeStyle(afsLowercaseStyle);
      IncludeStyle(afsUppercaseStyle);
      EndUpdate;
    end;
    WPRichText1.Refresh;
  end;
end;

procedure TWPDefAct.XA_FrmCap_OffExecute(Sender: TObject);
begin
  if WPRichText1 <> nil then
  begin
    with WPRichText1.TextCursor.CurrAttribute do
    begin
      BeginUpdate;
      ExcludeStyle(afsLowercaseStyle);
      ExcludeStyle(afsUppercaseStyle);
      EndUpdate;
    end;
    WPRichText1.Refresh;
  end;
end;

// -------------------------
// -------- Extras Menu
// -------------------------


procedure TWPDefAct.SetFGetWPRichText(x : TWPGetCurrentEditor);
var wp : TWPCustomRichText;
begin
  FGetWPRichText := x;
  if assigned(x) then
  begin
     x(Self, wp);
     if wp<>nil then
        wp.ActionList2 := StdActions;
  end;
end;

// -------------------------
// -------- Table Menu
// -------------------------

procedure TWPDefAct.XA_CreateTableExecute(Sender: TObject);
begin
  WPTableDlg1.EditBox := WPRichText1;
  WPTableDlg1.Execute;
end;

procedure TWPDefAct.Info1Click(Sender: TObject);
var s: string;
begin
  if (FOwnerComp <> nil) and Assigned(FOwnerComp.FOnInfo1) then
    FOwnerComp.FOnInfo1(Sender) else
    if Assigned(FOnInfo) then FOnInfo else
    begin
      s := '';
      if WPTools_IsPremiumVersion then s := ' PREMIUM';
{$IFDEF WPREPORTER}
{$IFDEF WPREPORTDEMO}
      s := s + ' + WPReporter Demo';
{$ELSE}
      s := s + ' + WPReporter';
{$ENDIF}
{$ENDIF}
      ShowMessage(
        String('WPTools, the word processing component suite by WPCubed GmbH' + #13 +
        'Info: http://www.wpcubed.com' + #13 +
        'Version ' + String(WPToolsVersion) + s));
    end;
end;

procedure TWPDefAct.XA_InfoExecute(Sender: TObject);
begin
  if (FOwnerComp <> nil) and Assigned(FOwnerComp.FOnInfo2) then
    FOwnerComp.FOnInfo2(Sender) else
    if Assigned(FOnInfo2) then FOnInfo2;
end;

procedure TWPDefAct.XA_ShowRepBandExecute(Sender: TObject);
begin
{$IFDEF WPREPORTER}
  if SuperMerge <> nil then
  begin
    BandDialog.SuperMerge := SuperMerge;
    BandDialog.EditBox := WPRichText1;
    BandDialog.StayOnTop := TRUE;
    BandDialog.DataBases.CommaText := SuperMerge.DataBases;
    BandDialog.ShowAddDeleteButton := TRUE;
    BandDialog.Show;
  end;
{$ENDIF}
end;

procedure TWPDefAct.XA_CreateReportExecute(Sender: TObject);
begin
{$IFDEF WPREPORTER}
  if (SuperMerge <> nil) and (ReportDest <> nil) then
  begin
    SuperMerge.Execute;
    WPPreviewDlg1.EditBox := ReportDest;
    WPPreviewDlg1.Modal := TRUE;
    WPPreviewDlg1.Show;
    ReportDest.Clear;
  end;
{$ENDIF}

end;



procedure TWPDefAct.GraphicOptionsClick(Sender: TObject);
begin
  if WPRichText1 <> nil then
  WPRichText1.SetImageMode(TWPSetImageMode((Sender as TComponent).Tag));
end;

procedure TWPDefAct.GraphicPopupMenuPopup(Sender: TObject);
var obj: TWPTextObj;
begin
  if (WPRichText1 <> nil) and (WPRichText1.SelectedObject <> nil) then
  begin
    obj := WPRichText1.SelectedObject;
    underovertext1.Enabled := (obj.Mode * [wpobjRelativeToParagraph, wpobjRelativeToPage]) <> [];
    underovertext1.Checked := wpobjObjectUnderText in obj.Mode;
    ascharacter1.Checked := not underovertext1.Enabled;
    reltoparautowrap1.Checked :=
      (wpobjRelativeToParagraph in obj.Mode) and
      (obj.Wrap = wpwrAutomatic);
    reltoparwrapleftandright1.Checked :=
      (wpobjRelativeToParagraph in obj.Mode) and
      (obj.Wrap = wpwrBoth);
    reltopagenowrappng1.Checked :=
      (wpobjRelativeToPage in obj.Mode) and
      (obj.Wrap = wpwrNone);
    reltopagewrapleftandright1.Checked :=
      (wpobjRelativeToPage in obj.Mode) and
      (obj.Wrap = wpwrBoth);
  end;
end;

// --------------------------------------------------------------------
// --------------------------------------------------------------------
// --------------------------------------------------------------------

constructor TWPDefaultActions.Create(aOwner: TComponent);
begin
  inherited Create(aOwner);
  if aOwner is TForm then
    FOwnerForm := aOwner as TForm;
  FWPDefAct := TWPDefAct.Create(nil);
  FWPDefAct.FOwnerComp := Self;
  FControlledMemos := TWPEditBoxLinkCollection.Create(Self);
  FControlledMemos.OnOnUpdateState := EditBoxStateMsg;
end;

destructor TWPDefaultActions.Destroy;
begin
  FWPDefAct.Free;
  FControlledMemos.Free;
  inherited Destroy;
end;

procedure TWPDefaultActions.SetLinks(x: TWPEditBoxLinkCollection);
begin
  FControlledMemos.Assign(x);
end;

procedure TWPDefaultActions.Loaded;
var i: Integer;
begin
  inherited Loaded;
  if not assigned(FWPDefAct.OnGetWPRichText) then
    FWPDefAct.OnGetWPRichText := GetToolsEditor;
  if FAssignMenu and
    (FOwnerForm <> nil) and
    (FOwnerForm.Menu = nil) and not (csDesigning in ComponentState)
    then
    FOwnerForm.Menu := FWPDefAct.MainMenu;
  for i := 0 to FControlledMemos.Count - 1 do
    if (FControlledMemos.Items[0].EditBox <> nil) then
    begin
      FControlledMemos.Items[0].EditBox.GraphicPopupMenu := FWPDefAct.GraphicPopupMenu;
      (FControlledMemos.Items[0].EditBox as TWPCustomRichText).ActionList :=
        FWPDefAct.StdActions;
    end;

     // Show Menus
  FWPDefAct.Export1.Visible := assigned(FOnExport);
  FWPDefAct.CloseFile1.Visible := assigned(FOnCloseFile);
  FWPDefAct.CloseApp1.Visible := assigned(FOnClose);
  FWPDefAct.MailTo1.Visible := assigned(FOnMailTo);
  FWPDefAct.ShowHorzRuler1.Visible := assigned(FOnShowHorzRuler);
  FWPDefAct.ShowVertRuler1.Visible := assigned(FOnShowVertRuler);
  FWPDefAct.ShowGutter1.Visible := assigned(FOnShowGutter);
  FWPDefAct.ShowThumbNails1.Visible := assigned(FOnShowThumbnails);

  if assigned(FOnInit) then
    FOnInit(FWPDefAct);
end;

procedure TWPDefaultActions.GetToolsEditor(Sender: TObject; var wp: TWPCustomRichText);
var i: Integer;
begin
  if FControlledMemos.Count = 1 then
    wp := FControlledMemos.Items[0].EditBox as TWPCustomRichText
  else
  begin
    for i := 0 to FControlledMemos.Count - 1 do
      if (FControlledMemos.Items[i].EditBox <> nil) and
        (FControlledMemos.Items[i].EditBox.Focused) then
        wp := FControlledMemos.Items[i].EditBox as TWPCustomRichText;
    if wp = nil then
      for i := 0 to FControlledMemos.Count - 1 do
        if (FControlledMemos.Items[i].EditBox = FLastEditor) then
          wp := FLastEditor;
  end;
  FLastEditor := wp;
end;

procedure TWPDefaultActions.EditBoxStateMsg(Sender: TPersistent;
  EditBox: TWPCustomRtfEdit; State: TWPEditBoxLinkMsg);
begin
  if (State = wpAfterGetFocus) and (EditBox is TWPRichtext) then
  begin
    FLastEditor := TWPRichtext(EditBox);
    TWPRichtext(EditBox).ActionList := FWPDefAct.StdActions;
  end;
end;

// -----------------------------------------------------------------------------
// -----------------------------------------------------------------------------
// -----------------------------------------------------------------------------

procedure TWPDefAct.SaveStrings;
var
  lst: TStringList;
  procedure SaveMenu(Menu: TMenuItem);
  var i: Integer;
  begin  
    for i := 0 to Menu.Count - 1 do
      if (Menu.Items[i].Caption <> '-') and
        (Menu.Items[i].Name <> '') then
      begin
        lst.Add('c_' + Menu.Items[i].Name + '=' + Menu.Items[i].Caption);
        if Menu.Items[i].Hint <> '' then
          lst.Add('h_' + Menu.Items[i].Name + '=' + Menu.Items[i].Hint);
        SaveMenu(Menu.Items[i]);
      end;
  end;
begin
  if Assigned(WPLangInterface) then
  begin
    lst := TStringList.Create;
    try
      SaveMenu(MainMenu.Items);
      WPLangInterface.SaveStrings('DefaultActions_MainMenu', lst, 0);
      lst.Clear;
      SaveMenu(GraphicPopupMenu.Items);
      WPLangInterface.SaveStrings('DefaultActions_GraphicPopupMenu', lst, 0);
    finally
      lst.Free;
    end;
  end;
end;

procedure TWPDefAct.LoadStrings;
var
  lst: TStringList;
  a: Integer;
  procedure LoadMenu(Menu: TMenu);
  var i, j: Integer;
    s: string;
    cmp: TComponent;
  begin
    for i := 0 to lst.Count - 1 do
    begin
      s := lst[i];
      j := Pos('=', s);
      if (j > 2) then
      begin
        cmp := {was: Menu.}FindComponent(Copy(s, 3, j - 3));
        if (cmp <> nil) and (cmp is TMenuItem) then
        begin
          if s[1] = 'c' then
            TMenuItem(cmp).Caption := Copy(s, j + 1, Length(s) - j)
          else if s[1] = 'h' then
            TMenuItem(cmp).Hint := Copy(s, j + 1, Length(s) - j);
        end;
      end;
    end;
  end;
 { procedure LoadActionCaptions(Menu: TMenuItem);
  var i : Integer;
  begin
      for i := 0 to Menu.Count-1 do
      begin
         if (Menu.Items[i].Action<>nil) and (Menu.Items[i].Action is TWPToolsCustomAction) then
         begin
            TWPToolsCustomAction(Menu.Items[i].Action).UpdateCaption;
            Menu.Items[i].Caption := TWPToolsCustomAction(Menu.Items[i].Action).Caption;
            Menu.Items[i].Hint := TWPToolsCustomAction(Menu.Items[i].Action).Hint;
         end;
         LoadActionCaptions( Menu.Items[i] );
      end;
  end;  }
  var i : Integer;
begin
  if Assigned(WPLangInterface) then
  begin
    // Load action strings
    for i := 0 to StdActions.ActionCount-1 do
     if StdActions[i] is TWPToolsCustomAction then
           TWPToolsCustomAction(StdActions[i] ).UpdateCaption;

    lst := TStringList.Create;
    try
      lst.Clear;
      //LoadActionCaptions(MainMenu.Items);
      if WPLangInterface.LoadStrings('DefaultActions_MainMenu', lst, a) then
      begin
        LoadMenu(MainMenu);
      end;
      lst.Clear;
      //LoadActionCaptions(GraphicPopupMenu.Items);
      if WPLangInterface.LoadStrings('DefaultActions_GraphicPopupMenu', lst, a) then
      begin
        LoadMenu(GraphicPopupMenu);
      end;
    finally
      lst.Free;
    end;
  end;
end;



end.

